CustomRun [tekton.dev/v1]
- Description
- CustomRun represents a single execution of a Custom Task.
- Type
object
Specification
.spec
- Description
- CustomRunSpec defines the desired state of CustomRun
- Type
object
.spec.customRef
- Description
- TaskRef can be used to refer to a specific instance of a task.
- Type
object
.spec.customRef.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.customRef.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.customSpec
- Description
- Spec is a specification of a custom task
- Type
object
.spec.customSpec.spec
- Description
- Spec is a specification of a custom task
- Type
object
.spec.params
- Description
- Params is a list of Param
- Type
array
.spec.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.workspaces
- Description
- Workspaces is a list of WorkspaceBindings from volumes to workspaces.
- Type
array
.spec.workspaces[]
- Description
- WorkspaceBinding maps a Task's declared workspace to a Volume.
- Type
object- Required
name
.spec.workspaces[].configMap
- Description
- ConfigMap represents a configMap that should populate this workspace.
- Type
object
.spec.workspaces[].configMap.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].configMap.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].csi
- Description
- CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers.
- Type
object- Required
driver
.spec.workspaces[].csi.nodePublishSecretRef
- Description
- nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
- Type
object
.spec.workspaces[].csi.volumeAttributes
- Description
- volumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
- Type
object
.spec.workspaces[].emptyDir
- Description
- EmptyDir represents a temporary directory that shares a Task's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir Either this OR PersistentVolumeClaim can be used.
- Type
object
.spec.workspaces[].persistentVolumeClaim
- Description
- PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. Either this OR EmptyDir can be used.
- Type
object- Required
claimName
.spec.workspaces[].projected
- Description
- Projected represents a projected volume that should populate this workspace.
- Type
object
.spec.workspaces[].projected.sources
- Description
- sources is the list of volume projections. Each entry in this list handles one source.
- Type
array
.spec.workspaces[].projected.sources[]
- Description
- Projection that may be projected along with other supported volume types. Exactly one of these fields must be set.
- Type
object
.spec.workspaces[].projected.sources[].clusterTrustBundle
- Description
- ClusterTrustBundle allows a pod to access the `.spec.trustBundle` field of ClusterTrustBundle objects in an auto-updating file. Alpha, gated by the ClusterTrustBundleProjection feature gate. ClusterTrustBundle objects can either be selected by name, or by the combination of signer name and a label selector. Kubelet performs aggressive normalization of the PEM contents written into the pod filesystem. Esoteric PEM features such as inter-block comments and block headers are stripped. Certificates are deduplicated. The ordering of certificates within the file is arbitrary, and Kubelet may change the order over time.
- Type
object- Required
path
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector
- Description
- Select all ClusterTrustBundles that match this label selector. Only has effect if signerName is set. Mutually-exclusive with name. If unset, interpreted as "match nothing". If set but empty, interpreted as "match everything".
- Type
object
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[].values[]
- Type
string
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.workspaces[].projected.sources[].configMap
- Description
- configMap information about the configMap data to project
- Type
object
.spec.workspaces[].projected.sources[].configMap.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].projected.sources[].configMap.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].projected.sources[].downwardAPI
- Description
- downwardAPI information about the downwardAPI data to project
- Type
object
.spec.workspaces[].projected.sources[].downwardAPI.items
- Description
- Items is a list of DownwardAPIVolume file
- Type
array
.spec.workspaces[].projected.sources[].downwardAPI.items[]
- Description
- DownwardAPIVolumeFile represents information to create the file containing the pod field
- Type
object- Required
path
.spec.workspaces[].projected.sources[].downwardAPI.items[].fieldRef
- Description
- Required: Selects a field of the pod: only annotations, labels, name, namespace and uid are supported.
- Type
object- Required
fieldPath
.spec.workspaces[].projected.sources[].downwardAPI.items[].resourceFieldRef
- Description
- Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
- Type
object- Required
resource
.spec.workspaces[].projected.sources[].podCertificate
- Description
- Projects an auto-rotating credential bundle (private key and certificate chain) that the pod can use either as a TLS client or server. Kubelet generates a private key and uses it to send a PodCertificateRequest to the named signer. Once the signer approves the request and issues a certificate chain, Kubelet writes the key and certificate chain to the pod filesystem. The pod does not start until certificates have been issued for each podCertificate projected volume source in its spec. Kubelet will begin trying to rotate the certificate at the time indicated by the signer using the PodCertificateRequest.Status.BeginRefreshAt timestamp. Kubelet can write a single file, indicated by the credentialBundlePath field, or separate files, indicated by the keyPath and certificateChainPath fields. The credential bundle is a single file in PEM format. The first PEM entry is the private key (in PKCS#8 format), and the remaining PEM entries are the certificate chain issued by the signer (typically, signers will return their certificate chain in leaf-to-root order). Prefer using the credential bundle format, since your application code can read it atomically. If you use keyPath and certificateChainPath, your application must make two separate file reads. If these coincide with a certificate rotation, it is possible that the private key and leaf certificate you read may not correspond to each other. Your application will need to check for this condition, and re-read until they are consistent. The named signer controls chooses the format of the certificate it issues; consult the signer implementation's documentation to learn how to use the certificates it issues.
- Type
object- Required
keyTypesignerName
.spec.workspaces[].projected.sources[].podCertificate.userAnnotations
- Description
- userAnnotations allow pod authors to pass additional information to the signer implementation. Kubernetes does not restrict or validate this metadata in any way. These values are copied verbatim into the `spec.unverifiedUserAnnotations` field of the PodCertificateRequest objects that Kubelet creates. Entries are subject to the same validation as object metadata annotations, with the addition that all keys must be domain-prefixed. No restrictions are placed on values, except an overall size limitation on the entire field. Signers should document the keys and values they support. Signers should deny requests that contain keys they do not recognize.
- Type
object
.spec.workspaces[].projected.sources[].secret
- Description
- secret information about the secret data to project
- Type
object
.spec.workspaces[].projected.sources[].secret.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].projected.sources[].secret.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].projected.sources[].serviceAccountToken
- Description
- serviceAccountToken is information about the serviceAccountToken data to project
- Type
object- Required
path
.spec.workspaces[].secret
- Description
- Secret represents a secret that should populate this workspace.
- Type
object
.spec.workspaces[].secret.items
- Description
- items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].secret.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.status
- Description
- CustomRunStatus defines the observed state of CustomRun
- Type
object
.status.annotations
- Description
- Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.
- Type
object
.status.conditions
- Description
- Conditions the latest available observations of a resource's current state.
- Type
array
.status.conditions[]
- Description
- Condition defines a readiness condition for a Knative resource. See: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#typical-status-properties
- Type
object- Required
statustype
.status.results
- Description
- Results reports any output result values to be consumed by later tasks in a pipeline.
- Type
array
.status.results[]
- Description
- CustomRunResult used to describe the results of a task
- Type
object- Required
namevalue
API Endpoints
The following API endpoints are available:
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customrunsDELETE: delete collection of CustomRunGET: list objects of kind CustomRunPOST: create a new CustomRun
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customruns/{name}DELETE: delete the specified CustomRunGET: read the specified CustomRunPATCH: partially update the specified CustomRunPUT: replace the specified CustomRun
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customruns/{name}/statusGET: read status of the specified CustomRunPATCH: partially update status of the specified CustomRunPUT: replace status of the specified CustomRun
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customruns
- HTTP method
DELETE- Description
- delete collection of CustomRun
- HTTP responses
- HTTP method
GET- Description
- list objects of kind CustomRun
- HTTP responses
- HTTP method
POST- Description
- create a new CustomRun
- Query parameters
- Body parameters
- HTTP responses
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customruns/{name}
- HTTP method
DELETE- Description
- delete the specified CustomRun
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified CustomRun
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified CustomRun
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified CustomRun
- Query parameters
- Body parameters
- HTTP responses
/apis/tekton.dev/v1beta1/namespaces/{namespace}/customruns/{name}/status
- HTTP method
GET- Description
- read status of the specified CustomRun
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified CustomRun
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified CustomRun
- Query parameters
- Body parameters
- HTTP responses